#ifndef AFCFLTCONFIG_H
#define AFCFLTCONFIG_H

class QSettings;

class AfcFltConfig  {
public:
    AfcFltConfig();
    AfcFltConfig(const AfcFltConfig &cfg);

    bool isManual() const {return m_manual;}
    bool enabled() const {return m_enabled;}
    double f0() const {return m_f0;}
    double fd0() const {return m_fd0;}
    double k(int ch_num) const {return m_k[ch_num];}

    void setEnabled(bool en) {m_enabled = en;}
    void setF0(double f0) {m_f0 = f0;}
    void setFd0(double fd0) {m_fd0 = fd0;}
    void setK(int ch_num, double k) { m_k[ch_num] = k; }
    void setManual(bool manual) {m_manual = manual;}

    void save(QSettings &set) const;
    void load(QSettings &set);

    static const int ch_cnt = 8;
    static constexpr bool   defaultEnabled() {return true;}
    static constexpr double defaultK() {return 0.16;}
    static constexpr double defaultF0() {return 10000;}
    static constexpr double defaultFd0() {return 192000;}
private:
    bool m_manual {false};
    bool m_enabled {false};
    double m_f0 {defaultF0()};
    double m_fd0 {defaultFd0()};
    double m_k[ch_cnt];
};

#endif // AFCFLTCONFIG_H
