#ifndef CONFIGDIALOG_H
#define CONFIGDIALOG_H


#include <QDialog>
#include "AfcFltConfig.h"

namespace Ui {
    class ConfigDialog;
}
namespace LQMeas {
    class LTR35;
}
class AfcFltConfig;
class QDoubleSpinBox;

class ConfigDialog : public QDialog {
    Q_OBJECT
public:
    explicit ConfigDialog(QWidget *parent, const AfcFltConfig &cfg, LQMeas::LTR35 *pltr35);
    ~ConfigDialog() override;

    void fillConfig(AfcFltConfig &cfg);
private Q_SLOTS:
    void showConfig();

    void setManual();
    void setEnabled();
    void setF0();
    void setFD0();
    void setK();
private:
    Ui::ConfigDialog *ui;
    QList<QDoubleSpinBox *> m_chsK;
    AfcFltConfig m_cfg;
    LQMeas::LTR35 *m_pltr35;
    bool m_ui_update {false};
};

#endif // CONFIGDIALOG_H
