#include "WaitDialog.h"
#include "ui_WaitDialog.h"

WaitDialog::WaitDialog(QWidget *parent) :
    QDialog{parent},
    ui{new Ui::WaitDialog} {

    ui->setupUi(this);
    ui->cancelBtn->setVisible(true);

    setWindowFlags(Qt::WindowType::Dialog |
                   Qt::WindowType::MSWindowsFixedSizeDialogHint |
                   Qt::WindowType::CustomizeWindowHint |
                   Qt::WindowType::WindowTitleHint);

    connect(ui->cancelBtn, &QPushButton::clicked, this, &WaitDialog::cancel);
}

WaitDialog::~WaitDialog() {
    delete ui;
}

void WaitDialog::setText(const QString &txt, bool isCancelable) {
    ui->label->setText(txt);
    ui->cancelBtn->setVisible(isCancelable);
}

void WaitDialog::cancel() {
    m_canceled = true;
}
