#ifndef SPINBOXDELEGATE_H
#define SPINBOXDELEGATE_H

#include <QStyledItemDelegate>

class SpinBoxDelegate : public QStyledItemDelegate {
    Q_OBJECT
public:
    static const int StepRole = Qt::UserRole + 1;
    static const int MaxRole = Qt::UserRole + 2;
    static const int MinRole = Qt::UserRole + 3;
    static const int SpecialValueTextRole = Qt::UserRole + 4;
    static const int PrefixTextRole = Qt::UserRole + 5;
    static const int SuffixTextRole = Qt::UserRole + 6;

    SpinBoxDelegate(QObject *parent = Q_NULLPTR);

    QWidget *createEditor(QWidget *parent, const QStyleOptionViewItem &option,
                          const QModelIndex &index) const override;

    void setEditorData(QWidget *editor, const QModelIndex &index) const override;
    void setModelData(QWidget *editor, QAbstractItemModel *model,
                      const QModelIndex &index) const override;

    void updateEditorGeometry(QWidget *editor,
        const QStyleOptionViewItem &option, const QModelIndex &index) const override;
};

#endif // SPINBOXDELEGATE_H
