#ifndef TREEPARAMSBASEITEM_H
#define TREEPARAMSBASEITEM_H

#include <QList>

class TreeParamsBaseItem {
public:
    virtual ~TreeParamsBaseItem();
    virtual TreeParamsBaseItem *treeParent() const = 0;
    virtual int treeChildrenCount() const  = 0;
    virtual TreeParamsBaseItem *treeChild(int idx) const = 0;


    void getChildrenRecursive(QList<TreeParamsBaseItem *>  &list) const {
        for (int i = 0; i < treeChildrenCount(); i++) {
            TreeParamsBaseItem *child = treeChild(i);
            list.append(child);
            child->getChildrenRecursive(list);
        }
    }
};

#endif // TREEPARAMSBASEITEM_H
