#ifndef LQMEAS_LTR35CONFIG_H
#define LQMEAS_LTR35CONFIG_H

#include "lqmeas/devs/DeviceConfig.h"
#include <QScopedPointer>
#include "LTR35OutConfig.h"
#include "LTR35SyncConfig.h"
#include "LTR35InConfig.h"

namespace LQMeas {

    class LTR35Config : public DeviceConfig {
        Q_OBJECT
    public:
        static const QString &typeConfigName();
        QString configDevTypeName() const override {return typeConfigName();}

        const DevOutConfig *outConfig() const override;
        const DevInDigConfig *inDigConfig() const override;
        const DevOutSyncConfig *outSyncConfig() const override;

        LTR35OutConfig &out() {return  m_out;}
        const LTR35OutConfig &out() const {return  m_out;}

        LTR35InConfig &in() {return m_in;}
        const LTR35InConfig &in() const {return m_in;}

        LTR35SyncConfig &sync() {return  m_sync;}
        const LTR35SyncConfig &sync() const {return  m_sync;}

        DeviceConfig *clone() const override {
            return new LTR35Config(*this);
        }

        LTR35Config();
        LTR35Config(const LTR35Config &cfg);
        ~LTR35Config() override;
    private:
        LTR35OutConfig m_out;
        LTR35InConfig m_in;
        LTR35SyncConfig m_sync;

    };
}

#endif // LQMEAS_LTR35CONFIG_H
