#include "DevInDigConfig.h"
#include <QJsonObject>
#include <QJsonArray>

#include "DevInDigInfo.h"
#include "lqmeas/devs/DeviceTypeInfo.h"

namespace LQMeas {
    DevInDigConfig::DevInDigConfig(const DevInDigInfo &devinfo) : m_in_dig_info{&devinfo} {

    }

    DevInDigConfig::DevInDigConfig(const DevInDigConfig &cfg) {
        m_in_dig_info = cfg.inDigInfo();
    }

    bool DevInDigConfig::inDigChAvailable(int ch) const {
        return inDigInfo()->inDigChAviable(ch);
    }

    void DevInDigConfig::inDigUpdateDevInfo(const DeviceTypeInfo *devinfo) {
        m_in_dig_info = devinfo->digin();
        protUpdateInfo(devinfo);
    }
}
